package org.jeecg.modules.toolCheck.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.api.model.ToolCheckResultDTO;
import org.jeecg.modules.tool.entity.Tool;
import org.jeecg.modules.tool.service.IToolService;
import org.jeecg.modules.toolCheck.entity.ToolCheck;
import org.jeecg.modules.toolCheck.service.IToolCheckService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.toolSheet.entity.ToolSheet;
import org.jeecg.modules.toolSheet.service.IToolSheetService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 工具委外检定
 * @Author: jeecg-boot
 * @Date: 2025-03-25
 * @Version: V1.0
 */
@Api(tags = "工具委外检定")
@RestController
@RequestMapping("/toolCheck/toolCheck")
@Slf4j
public class ToolCheckController extends JeecgController<ToolCheck, IToolCheckService> {
    @Autowired
    private IToolCheckService toolCheckService;
    @Autowired
    private IToolService toolService;
    @Autowired
    private IToolSheetService toolSheetService;

    /**
     * 分页列表查询
     *
     * @param toolCheck
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "工具委外检定-分页列表查询")
    @ApiOperation(value = "工具委外检定-分页列表查询", notes = "工具委外检定-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<ToolCheck>> queryPageList(ToolCheck toolCheck,
                                                  @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                  @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                  HttpServletRequest req) {
        QueryWrapper<ToolCheck> queryWrapper = QueryGenerator.initQueryWrapper(toolCheck, req.getParameterMap());
        Page<ToolCheck> page = new Page<ToolCheck>(pageNo, pageSize);
        IPage<ToolCheck> pageList = toolCheckService.page(page, queryWrapper);
        pageList.getRecords().forEach(item -> {
            ToolSheet toolSheet = toolSheetService.getById(item.getToolId());
            Tool tool = toolService.getById(toolSheet.getToolId());
            item.setToolName(tool.getName() + " " + toolSheet.getBrand() + "-" + toolSheet.getModel());
        });
        return Result.OK(pageList);
    }

    @ApiOperation(value = "工具委外检定-列表查询", notes = "工具委外检定-列表查询")
    @GetMapping(value = "/tml")
    public Result<List<ToolSheet>> queryToolSheetList() {
		List<Tool> checkTools = toolService.list(new LambdaQueryWrapper<Tool>().eq(Tool::getCheckRequire,"1"));
		if(checkTools.isEmpty()) return null;
		return Result.ok(toolSheetService.list(new LambdaQueryWrapper<ToolSheet>()
				.in(ToolSheet::getToolId,checkTools.stream().map(Tool::getId).collect(Collectors.toSet()))
                .orderByDesc(ToolSheet::getToolId)));
    }

    @ApiOperation(value = "工具委外检定-需送检列表查询", notes = "工具委外检定-需送检列表查询")
    @GetMapping(value = "/tmcl")
    public Result<ToolCheckResultDTO> queryToolSheetCheckList() {
        return Result.ok(toolCheckService.queryToolSheetCheckList());
    }

    /**
     * 添加
     *
     * @param toolCheck
     * @return
     */
    @AutoLog(value = "工具委外检定-添加")
    @ApiOperation(value = "工具委外检定-添加", notes = "工具委外检定-添加")
    //@RequiresPermissions("org.jeecg.modules:bu_tool_check:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody ToolCheck toolCheck) {
        toolCheckService.save(toolCheck);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param toolCheck
     * @return
     */
    @AutoLog(value = "工具委外检定-编辑")
    @ApiOperation(value = "工具委外检定-编辑", notes = "工具委外检定-编辑")
    //@RequiresPermissions("org.jeecg.modules:bu_tool_check:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody ToolCheck toolCheck) {
        try {
            toolCheckService.editToolCheck(toolCheck);
            return Result.OK("编辑成功!");
        }catch (Exception e) {
            return Result.error(e.getMessage());
        }
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "工具委外检定-通过id删除")
    @ApiOperation(value = "工具委外检定-通过id删除", notes = "工具委外检定-通过id删除")
    //@RequiresPermissions("org.jeecg.modules:bu_tool_check:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        toolCheckService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "工具委外检定-批量删除")
    @ApiOperation(value = "工具委外检定-批量删除", notes = "工具委外检定-批量删除")
    //@RequiresPermissions("org.jeecg.modules:bu_tool_check:deleteBatch")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.toolCheckService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "工具委外检定-通过id查询")
    @ApiOperation(value = "工具委外检定-通过id查询", notes = "工具委外检定-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<ToolCheck> queryById(@RequestParam(name = "id", required = true) String id) {
        ToolCheck toolCheck = toolCheckService.getById(id);
        if (toolCheck == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(toolCheck);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param toolCheck
     */
    //@RequiresPermissions("org.jeecg.modules:bu_tool_check:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ToolCheck toolCheck) {
        return super.exportXls(request, toolCheck, ToolCheck.class, "工具委外检定");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    //@RequiresPermissions("bu_tool_check:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ToolCheck.class);
    }

}
